/**
 * LabSD 3
 * lab3.cpp
 * Purpose: Driver program to run lab3 tasks.
 *
 * @author Gabriel Bercaru
 */

#include <iostream>

#include "Algorithms.h"
#include "DoublyLinkedList.h"
#include "ResizableArray.h"

void checkDoublyLinkedList() {
	DoublyLinkedList<int> dll;

	dll.addLast(4);
    dll.addLast(3);
    dll.addLast(2);
    dll.addLast(1);

    dll.addFirst(-1);
    dll.addFirst(-2);
    dll.addFirst(-3);
    dll.addFirst(-4);

    std::cout << "Linked list after adding some elements: " << dll << std::endl;

    dll.removeFirst();

    std::cout << "Linked list after removing the first element: " << dll << std::endl;
}

void checkResizableArray() {
	ResizableArray<int> ra;

	ra.addLast(1);
    ra.addLast(100);
    ra.addLast(110);
    ra.addLast(51);
    ra.addFirst(2);
    ra.addFirst(17);
    ra.addFirst(5);

    std::cout << "Resizable array after adding some elements: " << ra << std::endl;

    ra.removeFirst();
    ra.removeLast();

    std::cout << "Resizable array after removing some elements: " << ra << std::endl;
}

void checkResizableArrayLeftRotate() {
    ResizableArray<int> ra;
    int r = 3;

    ra.addLast(8);
    ra.addLast(62);
    ra.addLast(92);
    ra.addLast(8);
    ra.addLast(4);
    ra.addLast(7);

    std::cout << "Resizable array after adding some elements: " << ra << std::endl;

    Algorithms<int>::leftRotate(&ra, r);

    std::cout << "Resizable array after performing " << r << " left rotations: ";
    for (int i = 0; i < ra.size(); i++) {
        std::cout << ra.getData()[i] << " ";
    }
    std::cout << std::endl;
}

int main() {
    checkDoublyLinkedList();
    checkResizableArray();
    checkResizableArrayLeftRotate();

    return 0;
}
